<template>
  <div id="app">
    <block color="#ef5350">
      <text-field
        placeholder="All U Need Is Pizza"
        :value="filter"
        @input="filter = $event.target.value"
        :size="18"
        editable
      />
    </block>
    <block :height="285" color="#ffca28">
      <div class="listview">
        <row>
          <hyper-link slot="left-cell" @click="() => $router.history.push('/new')">New</hyper-link>
        </row>
        <row v-for="({ id, label, price }) in filteredPizzas.sort(byKey('label'))" :key="id">
          <hyper-link
            slot="left-cell"
            @click="() => $router.history.push(`/pizza/${id}`)"
          >{{ label }}</hyper-link>
          <text-field slot="right-cell">{{ price.toFixed(2) }} €</text-field>
        </row>
      </div>
    </block>
    <block color="#ffa726">
      <text-field :size="18">{{ filteredPizzas.length }} / {{ pizzas.length }}</text-field>
    </block>
  </div>
</template>

<script>
import { mapGetters } from 'vuex';
import { Block, Row, HyperLink, TextField } from '../layers';
import { lo, scrollToListView } from '@/utils';

export default {
  components: {
    Block,
    Row,
    HyperLink,
    TextField
  },
  data() {
    return {
      filter: ''
    };
  },
  computed: {
    ...mapGetters({
      pizzas: 'getPizzas'
    }),
    filteredPizzas() {
      return this.pizzas.filter(({ label }) => lo(label).includes(lo(this.filter)));
    }
  },
  mounted() {
    setTimeout(() => {
      scrollToListView();
    }, 1000);
  },
  methods: {
    byKey(key) {
      return (a, b) => (a[key] > b[key] ? 1 : a[key] < b[key] ? -1 : 0);
    }
  }
};
</script>

<style lang="scss">
#app {
  display: flex;
  flex-direction: column;
  justify-content: center;
  height: 90vh;

  > div {
    margin: 10px auto;
    width: 310px;
  }
}

.listview {
  display: flex;
  flex-direction: column;
  height: calc(100% - 10px);
  overflow-y: scroll;
  padding-bottom: 5px;
  margin: 0 auto;
  z-index: 2;
}
</style>
